]> git.pld-linux.org Git - projects/rc-scripts.git/blame - lib/functions
pidofproc: do not fallback, if pidfile was specified
[projects/rc-scripts.git] / lib / functions
CommitLineData
356d834b 1#!/bin/sh - keep it for file(1) to get bourne shell script result
7742e157 2# functions This file contains functions to be used by most or all
746a2130 3# shell scripts in the /etc/rc.d/init.d directory.
7742e157 4#
7742e157
AF
5#
6# Author: Miquel van Smoorenburg, <miquels@drinkel.nl.mugnet.org>
8a835e11 7# Hacked by: Greg Galloway and Marc Ewing
ffe19b59 8# Modified for PLD Linux by:
ec8b15cb 9# Marek Obuchowicz <elephant@pld-linux.org>
fdc764ae
ER
10# Arkadiusz Miśkiewicz <misiek@pld-linux.org>
11# Michał Kochanowicz <mkochano@pld-linux.org>
12# Łukasz Pawelczyk <havner@pld-linux.org>
7742e157
AF
13
14# First set up a default search path.
f2dd2d31 15export PATH="/sbin:/usr/sbin:/bin:/usr/bin"
7742e157 16
d7e5835b 17# Set defaults
66f7cfac
ER
18if [ -z "$COLUMNS" -o -z "$LINES" ]; then
19 _setterm() {
20 set -- $(stty size 2>/dev/null)
21 LINES=${LINES:-$1}
22 COLUMNS=${COLUMNS:-$2}
23 }
24 _setterm
25 unset _setterm
26fi
ef72e56c
AM
27[ -z "$LINES" ] || [ "$LINES" -le 0 ] && LINES=40
28[ -z "$COLUMNS" ] || [ "$COLUMNS" -le 0 ] && COLUMNS=80
66f7cfac
ER
29export LINES COLUMNS
30INIT_COL=$((COLUMNS - 13))
9e9fac7d 31
503bfc80
AM
32# Set colors
33RED=1
34GREEN=2
35YELLOW=3
36BLUE=4
37MAGENTA=5
38CYAN=6
39WHITE=7
94b691da 40NORMAL=15
503bfc80
AM
41# Bold definition (second parameter to termput setaf)
42BOLD=1
43NOBOLD=0
44# Default colors
45CBRACKETS="$CYAN" # brackets [ ] color
46CDONE="$GREEN" # DONE and WORK color
47CBUSY="$MAGENTA" # BUSY color
48CFAIL="$RED" # FAIL and DIED color
49CPOWEREDBY="$CYAN" # "Powered by" color
50CPLD="$GREEN" # "PLD Linux Distribution" color
51CI="$RED" # Capital I color (press I to enter interactive startup)
52CRESMAN="$GREEN" # "Resource Manager" color
bca43764 53CHARS="" # Characters displayed on the beginning of show line
503bfc80
AM
54CCHARS="$NORMAL" # Color of these characters (look at /etc/sysconfig/init-colors.gentoo example)
55
d7e5835b 56# Source configuration if available - may override default values
503bfc80 57[ -r /etc/sysconfig/init-colors ] && . /etc/sysconfig/init-colors
de1fc6ce 58[ -r /etc/sysconfig/system ] && . /etc/sysconfig/system
7f229d88 59[ -r /etc/sysconfig/bootsplash ] && . /etc/sysconfig/bootsplash
7e04fe0e 60
4fef8be6 61# if initscript is invoked via bash, enable RedHat/Fedora compatibility
1613208c
ER
62# RC_FEDORA is "set" if enabled and "unset" when not, but it's "value" is always empty
63# this is useful for inline constructs
4fef8be6
ER
64if [ "${BASH_VERSION+set}" = "set" ]; then
65 RC_LOGGING=yes
66 FASTRC=no
1613208c
ER
67 RC_FEDORA=
68else
69 unset RC_FEDORA || :
4fef8be6
ER
70fi
71
9e22837c 72if [ -z "$VSERVER" -o "$VSERVER" = "detect" ]; then
ce397bd8
JR
73 {
74 while read _f _ctx; do
75 [ "$_f" = "VxID:" -o "$_f" = "s_context:" ] && break
76 done </proc/self/status
77 } 2>/dev/null
9e22837c
JR
78 if [ -z "$_ctx" -o "$_ctx" = "0" ]; then
79 VSERVER=no
80 else
81 VSERVER=yes
82 fi
55a4bc1b 83 unset _f _ctx
9e22837c
JR
84fi
85
2a7fa780
AM
86# VSERVER_ISOLATION_NET = isolation only inside of vserver guests
87if [ -z "$VSERVER_ISOLATION_NET" -o "$VSERVER_ISOLATION_NET" = "detect" ]; then
88 VSERVER_ISOLATION_NET=no
89 if [ "$VSERVER" = "yes" ]; then
46e27e96 90 if [ -f /proc/self/nsproxy ]; then
61bf3b6f 91 # older kernels
46e27e96
ER
92 {
93 while read _t _data; do
94 [ "$_t" = "net:" ] && break
95 done < /proc/self/nsproxy
96 } 2> /dev/null
61bf3b6f
AM
97 if [ "${_data##*\(}" = "I)" ]; then
98 VSERVER_ISOLATION_NET=yes
99 fi
100 elif [ -f /proc/self/ninfo ]; then
101 # newer kernels
102 {
103 while read _t _data; do
104 [ "$_t" = "NCaps:" ] && break
105 done < /proc/self/ninfo
106 } 2> /dev/null
107 if [ "${_t}" = "NCaps:" ]; then
108 VSERVER_ISOLATION_NET=yes
109 fi
46e27e96 110 else
61bf3b6f 111 # assume (very?) old kernel mode
2a7fa780
AM
112 VSERVER_ISOLATION_NET=yes
113 fi
114 unset _f _data
115 fi
116fi
117
4132441e
ER
118# we need to know in functions if we were called from a terminal
119if [ -z "$ISATTY" ]; then
120 [ -t ] && ISATTY=yes || ISATTY=no
9cdf2de7 121 export ISATTY
4132441e
ER
122fi
123
18bd13ac 124is_yes() {
13a745bb 125 # Test syntax
ac1f65e1 126 if [ $# = 0 ]; then
13a745bb
AM
127 msg_usage " is_yes {value}"
128 return 2
129 fi
130
131 # Check value
132 case "$1" in
739070c4 133 yes|Yes|YES|true|True|TRUE|on|On|ON|Y|y|1)
13a745bb
AM
134 # true returns zero
135 return 0
136 ;;
739070c4 137 *)
13a745bb
AM
138 # false returns one
139 return 1
140 ;;
141 esac
142}
143
18bd13ac 144is_no() {
13a745bb 145 # Test syntax
ac1f65e1 146 if [ $# = 0 ]; then
13a745bb
AM
147 msg_usage " is_no {value}"
148 return 2
149 fi
150
151 case "$1" in
739070c4 152 no|No|NO|false|False|FALSE|off|Off|OFF|N|n|0)
13a745bb
AM
153 # true returns zero
154 return 0
155 ;;
739070c4 156 *)
13a745bb
AM
157 # false returns one
158 return 1
159 ;;
160 esac
161}
162
45e0ac73
ER
163# checks if file is empty
164# empty lines and lines beginning with hash are ignored
165is_empty_file() {
166 [ -s "$1" ] || return 0
a51d5138 167 grep -vqE "^(#|[[:blank:]]*$)" "$1" && return 1 || return 0
45e0ac73
ER
168}
169
1626fc86
ER
170# returns OK if $1 contains $2
171strstr() {
03e0c0fa 172 [ "${1#*$2*}" = "$1" ] && return 1
1626fc86
ER
173 return 0
174}
175
1cb6fa25
ER
176# Apply sysctl settings, including files in /etc/sysctl.d
177apply_sysctl() {
178 if [ -x /lib/systemd/systemd-sysctl ]; then
179 /lib/systemd/systemd-sysctl
180 return
181 fi
182
183 local file
184 for file in /usr/lib/sysctl.d/*.conf; do
185 [ -f /run/sysctl.d/${file##*/} ] && continue
186 [ -f /etc/sysctl.d/${file##*/} ] && continue
187 test -f "$file" && sysctl -q -e -p "$file"
188 done
189 for file in /run/sysctl.d/*.conf; do
190 [ -f /etc/sysctl.d/${file##*/} ] && continue
191 test -f "$file" && sysctl -q -e -p "$file"
192 done
193 for file in /etc/sysctl.d/*.conf; do
194 test -f "$file" && sysctl -q -e -p "$file"
195 done
196 sysctl -q -e -p /etc/sysctl.conf
197}
198
bd47641f 199if is_yes "$FASTRC" || is_yes "$IN_SHUTDOWN"; then
d84e0c78
JR
200 RC_LOGGING=no
201fi
202
bc94aa53 203if is_no "$RC_LOGGING"; then
18bd13ac 204 initlog() {
6d0838f4 205 RESULT=0
bb49a1c7 206 while [ "$1" != "${1##-}" ]; do
0a35929a 207 case $1 in
739070c4 208 -c)
5e6dfc29
JR
209 shift
210 $1
211 RESULT=$?
212 break
213 ;;
739070c4 214 *)
5e6dfc29
JR
215 shift
216 ;;
0a35929a
AM
217 esac
218 done
6d0838f4 219 return $RESULT
0a35929a
AM
220 }
221fi
222
18bd13ac 223kernelver() {
e9e5c299 224 local _x _y _z v v1 old_IFS ver
55a4bc1b
JR
225 {
226 read _x _y v _z
227 old_IFS=$IFS
e9e5c299
JR
228 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
229 IFS='_-'
55a4bc1b 230 set -- $v
e9e5c299
JR
231 v1=${1}
232 IFS='.'
233 set -- $v1
55a4bc1b 234 IFS=$old_IFS
28d62f54 235
e9e5c299 236 ver=${3}
28d62f54 237 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
55a4bc1b 238 ver="$2$ver"
28d62f54 239 while [ ${#ver} -lt 6 ]; do ver="0$ver"; done
55a4bc1b 240 ver="$1$ver"
28d62f54 241 while [ ${#ver} -lt 9 ]; do ver="0$ver"; done
55a4bc1b 242 echo $ver
28d62f54 243 } < /proc/version
6f2d09b1
AM
244}
245
18bd13ac 246kernelverser() {
480529b0 247 local _x _y _z v v1 old_IFS ver
55a4bc1b
JR
248 {
249 read _x _y v _z
250 old_IFS=$IFS
e9e5c299
JR
251 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
252 IFS='_-'
55a4bc1b 253 set -- $v
e9e5c299
JR
254 v1=${1}
255 IFS='.'
256 set -- $v1
55a4bc1b
JR
257 IFS=$old_IFS
258 ver=$2
ac1f65e1 259 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
55a4bc1b 260 ver="$1$ver"
ac1f65e1 261 while [ ${#ver} -lt 6 ]; do ver="0$ver"; done
55a4bc1b
JR
262 echo $ver
263 } </proc/version
6f2d09b1
AM
264}
265
18bd13ac 266kernelvermser() {
480529b0 267 local _x _y _z v v1 old_IFS ver
55a4bc1b
JR
268 {
269 read _x _y v _z
270 old_IFS=$IFS
e9e5c299
JR
271 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
272 IFS='_-'
55a4bc1b 273 set -- $v
e9e5c299
JR
274 v1=${1}
275 IFS='.'
276 set -- $v1
55a4bc1b 277 IFS=$old_IFS
e9e5c299 278 ver="$1"
ac1f65e1 279 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
55a4bc1b
JR
280 echo $ver
281 } </proc/version
6f2d09b1
AM
282}
283
cee18a41 284# Colors workaround
18bd13ac 285termput() {
4132441e 286 is_yes "$ISATTY" || return
e3aafb2f 287
294b03eb 288 if is_yes "$FASTRC" || is_no "$TPUT"; then
972964bb 289 case "$1" in
739070c4 290 hpa)
8a835e11 291 echo -ne "\033[$(($2+1))G"
972964bb 292 ;;
739070c4 293 cuu*)
8a835e11 294 echo -ne "\033[${2}A"
972964bb 295 ;;
739070c4 296 el)
8a835e11 297 echo -ne "\033[0K"
972964bb 298 ;;
739070c4 299 setaf)
944d6d80 300 local ISBOLD
503bfc80
AM
301 if [ -n "$3" ]; then
302 ISBOLD="$3"
303 else
304 ISBOLD="$NOBOLD";
305 fi
306 is_yes "$COLOR_INIT" && echo -ne "\033[${ISBOLD};3${2}m"
8a835e11 307 ;;
739070c4 308 op)
503bfc80 309 termput setaf $NORMAL
dcb00bd9 310 ;;
8a835e11 311 esac
c6c1bd0c 312 else
8a835e11 313 case "$1" in
739070c4 314 hpa | cuu* | el)
8a835e11 315 tput "$@"
945790a2 316 ;;
739070c4 317 setaf)
ac1f65e1 318 if [ "$3" = "1" ]; then tput bold; else tput sgr0; fi
503bfc80 319 is_yes "$COLOR_INIT" && tput setaf "$2"
945790a2 320 ;;
739070c4 321 op)
503bfc80 322 termput setaf $NORMAL
945790a2 323 ;;
8a835e11 324 esac
c6c1bd0c
AF
325 fi
326}
cee18a41 327
0c4f3cf5
ER
328if [ ! -x /bin/printf ]; then
329 # printf equivalent
330 # FIXME: buggy when single or double quotes in message!
18bd13ac 331 printf() {
944d6d80 332 local text m
0c4f3cf5
ER
333 text="$1"
334 shift
335 if [ $# -gt 0 ]; then
336 m="$1"
337 shift
338 while [ $# -gt 0 ]; do
339 m="$m\",\"$1"
340 shift
341 done
342 fi
343 awk "BEGIN {printf \"$text\", \"$m\"; }"
344 }
345fi
8a835e11 346
38198f50 347# National language support function
18bd13ac 348nls() {
944d6d80 349 local msg_echo nls_domain text message
d553f606 350 msg_echo='\n'
50ed8c3f 351 nls_domain="$NLS_DOMAIN"
e2c2c3a6 352 while [ "$1" != "${1##-}" ]; do
d553f606 353 case "$1" in
739070c4 354 --nls-domain)
8a835e11 355 shift
50ed8c3f 356 nls_domain="$1"
8a835e11 357 shift
358 ;;
739070c4 359 -n)
8a835e11 360 msg_echo=''
361 shift
362 ;;
d553f606
JR
363 esac
364 done
365 message="$1"
366 shift
50ed8c3f 367
d553f606
JR
368 # empty message, so we return --misiek
369 if [ -z "$message" ]; then
d553f606
JR
370 echo -en "$msg_echo"
371 return
38198f50 372 fi
8a835e11 373
e2c2c3a6
ER
374 if is_yes "$GETTEXT"; then
375 message=$(TEXTDOMAINDIR="/etc/sysconfig/locale" gettext -e --domain="${nls_domain:-rc-scripts}" "$message")
972964bb 376 fi
8a835e11 377
e2c2c3a6 378 printf "$message" "$@"
d553f606 379 echo -en "$msg_echo"
38198f50
AM
380}
381
18bd13ac 382rc_splash() {
944d6d80 383 local action="$1"
862c980c 384
9e22837c 385 if ! is_no "$BOOT_SPLASH" && ! is_yes "$VSERVER"; then
fae22957
AM
386 [ -x /bin/splash ] && /bin/splash "$action"
387 fi
b6509675
AM
388
389 : $((progress++))
fae22957
AM
390}
391
18bd13ac 392msg_network_down() {
228edf1d 393 nls "ERROR: Networking is down. %s can't be run." "$1" >&2
a916d1c6 394}
395
18bd13ac 396msg_starting() {
a916d1c6 397 show "Starting %s service" "$1"
398}
399
18bd13ac 400msg_already_running() {
599d198a 401 nls "%s service is already running." "$1"
a916d1c6 402}
403
18bd13ac 404msg_stopping() {
a916d1c6 405 show "Stopping %s service" "$1"
406}
407
18bd13ac 408msg_not_running() {
599d198a 409 nls "%s service is not running." "$1"
a916d1c6 410}
411
18bd13ac 412msg_reloading() {
a916d1c6 413 show "Reloading %s service" "$1"
414}
415
18bd13ac 416msg_usage() {
599d198a 417 nls "Usage: %s" "$*"
a916d1c6 418}
419
ffe19b59 420# Some functions to handle PLD Linux-style messages
18bd13ac 421show() {
b5dc86cd
ER
422 local text len time
423
9f2e06ae 424 if is_yes "$RC_UPTIME"; then
b5dc86cd
ER
425 time=$(awk '{printf("[%8.2f] ", $1)}' /proc/uptime)
426 fi
0a35929a 427
ce410bbc 428 if is_no "$FASTRC" && is_yes "$GETTEXT"; then
b5dc86cd 429 text=$time$(nls -n "$@")
ce410bbc 430 else
b5dc86cd 431 text=$time$(printf "$@")
ce410bbc
JR
432 fi
433 len=${#text}
434 while [ $((len++)) -lt $INIT_COL ]; do
435 text="$text."
436 done
437 if [ -n "$CHARS" ]; then
438 termput setaf $CCHARS
439 echo -n "$CHARS"
440 termput op
441 fi
442 echo -n "$text"
7742e157
AF
443}
444
18bd13ac 445deltext() {
a292b175
ER
446 termput hpa $INIT_COL
447}
448
b9cad282 449# Displays message in square brackests ("[ DONE ]"). Takes two arguments.
450# First is the text to display, second is color number to use (argument to
451# tput setaf). If second argument is not given, default (2, green) will be
452# used).
18bd13ac 453progress() {
944d6d80
ER
454 local COLOR
455 if [ -n "$2" ]; then
7e7efad2 456 COLOR="$2"
944d6d80 457 else
7e7efad2 458 COLOR="$CDONE"
944d6d80 459 fi
cd8dfdf0 460 deltext
503bfc80 461 echo -n "$(termput setaf $CBRACKETS)[$(termput setaf $COLOR) $(nls --nls-domain rc-scripts "$1") $(termput setaf $CBRACKETS)]$(termput op)"
b9cad282 462}
463
18bd13ac 464busy() {
a292b175 465 echo -n "$_busy"
7742e157
AF
466}
467
18bd13ac 468ok() {
1b9009e9 469 echo -ne "$_ok${RC_FEDORA+\\r}${RC_FEDORA-\\n}"
7742e157
AF
470}
471
18bd13ac 472started() {
a292b175 473 echo "$_started"
7e04fe0e 474}
475
18bd13ac 476fail() {
1b9009e9 477 echo -ne "$_fail${RC_FEDORA+\\r}${RC_FEDORA-\\n}"
d553f606 478 return 1
7742e157
AF
479}
480
18bd13ac 481died() {
a292b175 482 echo "$_died"
d553f606 483 return 1
6cac3cb2 484}
485
bbb612de 486# Check if $pid (could be plural) are running
18bd13ac 487checkpid() {
8a835e11 488 while [ "$1" ]; do
489 [ -d "/proc/$1" ] && return 0
490 shift
491 done
492 return 1
bbb612de
AM
493}
494
290eb891
AM
495# - outside chroot get only those processes, which are outside chroot.
496# - inside chroot get only those processes, which are inside chroot.
497# - don't filter out pids which do not have corresponding running processes (process died etc)
1e5e8177 498# (note: some processes like named are chrooted but run outside chroot)
c3403882 499# - do nothing inside vserver
18bd13ac 500filter_chroot() {
3a69d634
ER
501 # no pids, exit early
502 [ $# -eq 0 ] && return
503
1c1b41b1
ER
504 # filter by pid namespace if such dir exists for current process
505 # we do filter in containers as stacked containers are possible with LXC
506 if [ -d /proc/$$/ns ]; then
507 local pids
508 pids=$(filter_ns "$@") && set -- "$pids"
509 fi
510
c3403882
JR
511 if is_yes "$VSERVER"; then
512 echo $@
513 return
514 fi
1c1b41b1 515
ac1f65e1 516 if [ $# -lt 1 -o ! -d /proc/1 ]; then
8e3b6875
AM
517 echo $@
518 return
519 fi
1c1b41b1 520
33ca787f 521 local root_dir good_pids="" good_add_pid
1e5e8177
AM
522 for root_pid in $@; do
523 root_dir=$(resolvesymlink /proc/${root_pid}/root)
524 if [ -n "$root_dir" ]; then
5a8ff397
AM
525 good_add_pid=1
526 if [ -n "${SYSTEM_CHROOTS}" ]; then
527 for r_dir in ${SYSTEM_CHROOTS}; do
528 echo "$root_dir" | grep -q "^${r_dir}" && good_add_pid=0
529 done
530 fi
531 [ "$good_add_pid" -eq 1 ] && good_pids="$good_pids $root_pid"
290eb891
AM
532 elif [ ! -d "/proc/$root_pid" ]; then
533 good_pids="$good_pids $root_pid"
1e5e8177 534 fi
5a8ff397
AM
535 done
536 echo $good_pids
1e5e8177
AM
537}
538
1c1b41b1
ER
539# similar to filter_chroot, but filter based on /proc/PID/ns/pid value
540filter_ns() {
541 local cur_ns=$(resolvesymlink /proc/$$/ns/pid)
542 [ "$cur_ns" ] || return 1
543
544 local pid ns pids=""
8b972460
ER
545 # add pids if it matches current pid namespace
546 # we should add pids what do not exist (dead processes),
547 # but not add pids whose namespace does not match
548 # (processes belonging to different NS do exist in /proc)
1c1b41b1 549 for pid in "$@"; do
8b972460
ER
550 if [ ! -d /proc/$pid ]; then
551 pids="$pids $pid"
552 continue
553 fi
1c1b41b1 554 ns=$(resolvesymlink /proc/$pid/ns/pid)
8b972460 555 if [ "$ns" = "$cur_ns" ]; then
1c1b41b1
ER
556 pids="$pids $pid"
557 fi
558 done
559 echo $pids
560 return 0
561}
562
3e224b2a
ER
563# Usage:
564# run_cmd Message command_to_run
565# run_cmd -a Message command_to_run
566# run_cmd --user "username" "Message" command_to_run
18bd13ac 567run_cmd() {
3e224b2a
ER
568 local force_err=0 exit_code=0 errors user
569 while [ $# -gt 0 ]; do
570 case "$1" in
571 -a)
572 force_err=1
573 ;;
574 --user)
575 shift
576 user=$1
577 ;;
578 *)
579 break
580 esac
8a835e11 581 shift
3e224b2a
ER
582 done
583
584 local message=$1; shift
d553f606 585 show "$message"; busy
3e224b2a 586
f10f2102 587 if errors=$(
3e224b2a 588 cd /
f10f2102
ER
589 export HOME=/tmp TMPDIR=/tmp
590 if is_no "$RC_LOGGING"; then
3e224b2a 591 ${user:+setuidgid -s $user} "$@" 2>&1
f10f2102 592 else
3e224b2a 593 ${user:+setuidgid -s $user} initlog -c "$*" 2>&1
f10f2102
ER
594 fi
595 ); then
cd8dfdf0 596 ok
d553f606 597 log_success "$1 $message"
1b228409 598 else
d553f606
JR
599 fail
600 log_failed "$1 $message"
b7299ffc 601 exit_code=1
1b228409 602 fi
d553f606 603 [ -n "$errors" ] && [ $exit_code -eq 1 -o $force_err -eq 1 ] && echo "$errors"
1b228409 604 return $exit_code
cee18a41
AM
605}
606
e81194ca 607_daemon_set_ulimits() {
0fba6fe4
ER
608 local opt val ksh=${KSH_VERSION:+1}
609 set -- ${SERVICE_LIMITS:-$DEFAULT_SERVICE_LIMITS}
610 while [ $# -gt 0 ]; do
611 opt=$1
612 val=$2
613 if [ "$ksh" ]; then
614 case "$opt" in
615 -Hu)
616 opt=-Hp
617 ;;
618 -Su)
619 opt=-Sp
620 ;;
621 -u)
622 opt=-p
623 ;;
624 esac
625 fi
626 ulimit $opt $val
627 shift 2
628 done
e81194ca
ER
629}
630
e2e24f5a 631# A function to start a program (now it's useful on read-only filesystem too)
18bd13ac 632daemon() {
944d6d80
ER
633 local errors="" prog="" end="" waitname="" waittime=""
634 local exit_code=0
42595a81 635 local nice=$SERVICE_RUN_NICE_LEVEL
64c571c5 636 local fork user closefds redirfds pidfile makepid chdir=/
42595a81 637
210ff16f
ER
638 # NOTE: if you wonder how the shellish (by syntax) $prog works in ssd mode,
639 # then the answer is: it totally ignores $prog and uses "$@" itself.
640
42595a81 641 while [ $# -gt 0 ]; do
d553f606 642 case $1 in
739070c4 643 '')
64c571c5 644 msg_usage " daemon [--check] [--user user] [--fork] [--chdir directory] [--closefds] [--redirfds] [--waitforname procname] [--waitfortime seconds] [--pidfile file] [--makepid] [+/-nicelevel] {program} <program args>"
8a835e11 645 return 2
d553f606 646 ;;
739070c4 647 --check)
d553f606
JR
648 # for compatibility with redhat/mandrake
649 nls "warning: --check option is ignored!"
650 shift
d553f606 651 ;;
739070c4 652 --user)
d553f606 653 shift
f10f2102 654 user=$1
d553f606 655 ;;
739070c4
ER
656 --fork)
657 fork=1
b486c392 658 end='&'
b486c392 659 ;;
6b1fd029
ER
660 --chdir)
661 shift
662 chdir=$1
663 ;;
739070c4
ER
664 --closefds)
665 closefds=1
f10f2102 666 ;;
64c571c5
ER
667 --redirfds)
668 redirfds=1
669 ;;
739070c4 670 --waitforname)
b486c392 671 shift
683d384e 672 waitname="$1"
683d384e 673 ;;
739070c4 674 --waitfortime)
b486c392 675 shift
683d384e 676 waittime="$1"
683d384e 677 ;;
b2922b09
ER
678 --pidfile=?*)
679 pidfile="${1#--pidfile=}"
680 case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
681 ;;
739070c4 682 --pidfile)
0a177614
ER
683 shift
684 pidfile="$1"
5bf237b7 685 case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
0a177614 686 ;;
a160c01b
PG
687 --makepid)
688 makepid=1
689 ;;
739070c4 690 -*|+*)
42595a81 691 nice=$1
a6e727aa 692 shift
42595a81
ER
693 break
694 ;;
739070c4 695 *)
42595a81 696 break
683d384e 697 ;;
d553f606 698 esac
42595a81 699 shift
d553f606 700 done
af8469fc
KK
701 if [ -n "$user" -a "$user" != "root" ]; then
702 prog="/bin/su $user -s /bin/sh -c \""
703 fi
df2868ff 704 if [ "$fork" = "1" ]; then
af8469fc
KK
705 prog="/usr/bin/setsid ${prog:-sh -c \"}"
706 fi
2eea8492 707 # If command to execute ends with quotation mark, add remaining
708 # arguments and close quotation.
709 if [ "$prog" != "${prog%\"}" ]; then
565736ed 710 prog="$prog $*$end\""
2eea8492 711 else
565736ed 712 prog="$prog $*$end"
2eea8492 713 fi
7742e157 714
e81194ca 715 _daemon_set_ulimits
f054a85e 716
3edf5e48 717 [ -z "$DEFAULT_SERVICE_UMASK" ] && DEFAULT_SERVICE_UMASK=022
42595a81 718 [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
3edf5e48 719
7742e157
AF
720 # And start it up.
721 busy
6b1fd029 722 cd $chdir
42595a81 723 [ -n "$SERVICE_CPUSET" ] && is_yes "$CPUSETS" && echo $$ > "/dev/cpuset/${SERVICE_CPUSET}/tasks"
18bd13ac 724 if errors=$(
f10f2102 725 umask ${SERVICE_UMASK:-$DEFAULT_SERVICE_UMASK};
739070c4 726 export USER=root HOME=/tmp TMPDIR=/tmp
ab94cba2 727
f10f2102
ER
728 nice=${nice:-$DEFAULT_SERVICE_RUN_NICE_LEVEL}
729 nice=${nice:-0}
730
ab94cba2 731 # make nice level absolute, not to be dependant of nice level of shell where service started
667e4dd4 732 nice=$(($nice - $(nice)))
ab94cba2 733
f10f2102
ER
734 if [ "$closefds" = 1 ]; then
735 exec 1>&-
736 exec 2>&-
289e2982 737 exec 0<&-
64c571c5
ER
738 elif [ "$redirfds" = 1 ]; then
739 exec 1>/dev/null
740 exec 2>/dev/null
289e2982 741 exec 0</dev/null
f10f2102
ER
742 else
743 exec 2>&1
289e2982 744 exec 0</dev/null
f10f2102
ER
745 fi
746
ac1f65e1 747 if is_no "$RC_LOGGING"; then
f10f2102
ER
748 prog=$1; shift
749 if [ ! -x $prog ]; then
750 logger -t rc-scripts -p daemon.debug "daemon: Searching PATH for $prog, consider using full path in initscript"
751 local a o=$IFS
752 IFS=:
753 for a in $PATH; do
754 if [ -x $a/$prog ]; then
755 prog=$a/$prog
756 break
757 fi
758 done
759 IFS=$o
760 fi
b27454e3
ER
761 set -- "$prog" "$@"
762
9ecaca50
ER
763 # use setsid to detach from terminal,
764 # needs pidfile or ssd would check setsid program instead of real program
765 if [ "$pidfile" ]; then
766 set -- /usr/bin/setsid "$@"
767 fi
768
c45824b8 769 prog=$1; shift
f10f2102
ER
770 /sbin/start-stop-daemon -q --start \
771 --nicelevel $nice \
772 ${pidfile:+--pidfile $pidfile} \
86ed0b8f 773 ${makepid:+--make-pidfile} \
8a5b611f 774 ${user:+--chuid $user} \
6b1fd029 775 ${chdir:+--chdir "$chdir"} \
86ed0b8f 776 ${fork:+--background} \
69bdc5ba 777 ${SERVICE_DROPCAPS:+--dropcap $SERVICE_DROPCAPS} \
c45824b8 778 --exec "$prog" \
b27454e3 779 -- "$@"
f10f2102 780 else
8b8343d4 781 nice -n $nice initlog -c "$prog" 2>&1 </dev/null
f10f2102 782 fi
18bd13ac 783 ); then
f10f2102 784
683d384e
AM
785 if [ -n "$waitname" -a -n "$waittime" ]; then
786 # Save basename.
03e01a49 787 base=${waitname##*/}
683d384e
AM
788 # Find pid.
789 pid=$(pidofproc "$waitname" "$pidfile")
790 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
791 i=0
792 while [ "$i" -lt "$waittime" ]; do
42595a81 793 i=$((i + 1))
ff2643b0
ER
794 checkpid $pid && break
795 sleep 1
683d384e
AM
796 done
797 fi
d553f606 798 log_success "$1 startup"
1b228409 799 ok
7742e157 800 else
b7299ffc 801 exit_code=1
1b228409 802 fail
d553f606 803 log_failed "$1 startup"
4fbe82fd 804 [ -n "$errors" ] && echo >&2 "$errors"
7742e157 805 fi
b7299ffc 806 return $exit_code
7742e157
AF
807}
808
809# A function to stop a program.
18bd13ac 810killproc() {
b2922b09 811 local notset killlevel base pid pidfile result delay=3 try
7742e157
AF
812 # Test syntax.
813 if [ $# = 0 ]; then
b2922b09 814 msg_usage " killproc [--pidfile|-p PIDFILE] [-d DELAY] {program} [-SIGNAME]"
228edf1d 815 return 2
7742e157
AF
816 fi
817
bb49a1c7 818 while [ "$1" != "${1##-}" ]; do
8de7f381 819 case $1 in
b2922b09
ER
820 -d)
821 delay="$2"
822 shift 2
823 ;;
a5363bea 824 --pidfile|-p)
53ae90e8 825 pidfile="$2"
5bf237b7 826 case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
53ae90e8 827 shift 2
8de7f381 828 ;;
739070c4 829 --waitforname)
53ae90e8
ER
830 waitname="$2"
831 shift 2
683d384e 832 ;;
739070c4 833 --waitfortime)
53ae90e8
ER
834 waittime="$2"
835 shift 2
683d384e 836 ;;
8de7f381
AM
837 esac
838 done
839
7742e157 840 busy
8a835e11 841
944d6d80 842 local notset=0
7742e157 843 # check for second arg to be kill level
ac1f65e1 844 if [ -n "$2" ]; then
7742e157
AF
845 killlevel=$2
846 else
847 notset=1
7742e157
AF
848 fi
849
2f269bdf
ER
850 # experimental start-stop-daemon based killing.
851 # works only with pidfile
852 if is_no "$RC_LOGGING" && [ "$pidfile" ]; then
6154a5ce 853 local sig=${killlevel:--TERM} retry
57444cae 854 # do not retry if signal is specified,
b2922b09 855 # as otherwise impossible to send HUP if process pid stays in pidfile.
57444cae
ER
856 # however, do retry if --waitfortime was specified
857 if [ "${killlevel+set}" = "set" ] && [ -z "$waittime" ]; then
6154a5ce
ER
858 # if we send HUP it's ok if process does not die
859 retry="--oknodo"
860 else
57444cae
ER
861 local waitretry
862 : ${waittime=10}
863 : ${waitretry=$(($waittime * 2))}
864
865 # 1. kill with $sig, wait $delay
866 # 2. kill with $sig, wait $waittime
867 # 3. kill with KILL, wait $waitretry
868 retry="--retry ${sig#-}/${delay}/${sig#-}/${waittime}/KILL/${waitretry}"
6154a5ce 869 fi
2e00b711 870 /sbin/start-stop-daemon -q --stop \
6154a5ce 871 $retry \
57444cae 872 ${waitname:+--name $waitname} \
2f269bdf
ER
873 -s ${sig#-} \
874 ${pidfile:+--pidfile $pidfile}
875 result=$?
876 if [ "$result" -eq 0 ]; then
877 ok
878 else
879 fail
880 fi
881 return $result
882 fi
883
884
228edf1d 885 # Save basename.
03e01a49 886 base=${1##*/}
7742e157 887
228edf1d 888 # Find pid.
8de7f381
AM
889 pid=$(pidofproc "$1" "$pidfile")
890 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
7742e157 891
228edf1d 892 # Kill it.
ac1f65e1
TP
893 if [ -n "$pid" -a "$pid" != "$$" ] && checkpid $pid 2>&1; then
894 if [ "$notset" = "1" ]; then
228edf1d 895 if checkpid $pid 2>&1; then
896 # TERM first, then KILL if not dead
897 kill -TERM $pid
b2922b09
ER
898 usleep 50000
899
900 try=0
901 while [ $try -lt $delay ]; do
902 checkpid $pid || break
903 sleep 1
904 try=$((try+1))
905 done
906 if checkpid $pid; then
53ae90e8
ER
907 # XXX: SIGKILL is sent already on 4th second!
908 # HARMFUL for example to mysqld (which is already workarounded)
228edf1d 909 kill -KILL $pid
b2922b09 910 usleep 50000
228edf1d 911 fi
7742e157 912 fi
228edf1d 913 checkpid $pid
bbb612de
AM
914 result=$?
915 if [ "$result" -eq 0 ]; then
228edf1d 916 fail
917 log_failed "$1 shutdown"
918 else
919 ok
920 log_success "$1 shutdown"
921 fi
922 result=$(( ! $result ))
923 else
924 # use specified level only
925 if checkpid $pid > /dev/null 2>&1; then
926 kill $killlevel $pid
927 result=$?
928 if [ "$result" -eq 0 ]; then
929 ok
930 log_success "$1 got $killlevel"
931 else
932 result=7
933 fail
934 log_failed "$1 didn't get $killlevel"
935 fi
e016cdae 936 else
228edf1d 937 result=7
938 died
939 log_failed "$1 shutdown"
e016cdae 940 fi
7742e157
AF
941 fi
942 else
228edf1d 943 died
944 log_failed "$1 shutdown"
945 result=7
7742e157 946 fi
5e6dfc29 947
683d384e 948 if [ -n "$waitname" -a -n "$waittime" ]; then
e6f93a80 949 # Save basename.
03e01a49 950 base=${waitname##*/}
e6f93a80
AM
951 # Find pid.
952 pid=$(pidofproc "$waitname" "$pidfile")
953 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
683d384e
AM
954 i=0
955 while [ "$i" -lt "$waittime" ]; do
1101d321 956 i=$(( i + 1 ))
683d384e
AM
957 checkpid $pid && sleep 1 || break
958 done
959 fi
7742e157 960
228edf1d 961 # Remove pid file if any.
e016cdae 962 if [ "$notset" = "1" ]; then
228edf1d 963 rm -f /var/run/${base}.pid
7742e157 964 fi
bbb612de
AM
965
966 return $result
7742e157
AF
967}
968
969# A function to find the pid of a program.
18bd13ac 970pidofproc() {
944d6d80 971 local pid pidfile base=${1##*/}
8de7f381
AM
972 pidfile="$base.pid"
973 [ -n "$2" ] && pidfile="$2"
7742e157 974
8a835e11 975 # Test syntax.
ac1f65e1 976 if [ $# = 0 ]; then
8a835e11 977 msg_usage " pidofproc {program}"
978 return 2
979 fi
980
8de7f381 981 # First try pidfile or "/var/run/*.pid"
5bf237b7
ER
982 case "$pidfile" in
983 /*)pidfile="${pidfile}";;
984 *) pidfile="/var/run/$pidfile";;
985 esac
ac1f65e1 986 if [ -f "${pidfile}" ]; then
597298b3 987 local p
7eb94de6 988 for p in $(< "${pidfile}"); do
3030e60e 989 [ -z "$(echo "$p" | awk '{gsub(/[0-9]/,"");print;}')" ] && pid="$pid $p"
8a835e11 990 done
7742e157 991 fi
8a835e11 992
2ec0a78e
ER
993 # Next try "pidof" if pidfile is not specified
994 if [ -z "$pid" ] && [ -z "$pidfile" ]; then
597298b3
ER
995 pid=$(pidof -o $$ -o $PPID -o %PPID -x "$1")
996 fi
997
1c1b41b1 998 pid=$(filter_chroot $pid)
1e5e8177 999 echo $pid
7742e157 1000}
12de71be 1001
1b59b41b 1002# status [--pidfile PIDFILE] {subsys} [{daemon}]"
18bd13ac 1003status() {
944d6d80 1004 local pid subsys daemon cpuset_msg pidfile
3232ec7b 1005 if [ "$1" = "--pidfile" -o "$1" = "-p" ]; then
4e901aa0 1006 pidfile=$2
5bf237b7 1007 case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
4e901aa0
ER
1008 shift 2
1009 fi
1010
8a835e11 1011 subsys=$1
1012 daemon=${2:-$subsys}
bbb612de 1013
8a835e11 1014 # Test syntax.
ac1f65e1 1015 if [ $# = 0 ]; then
4e901aa0 1016 msg_usage " status [--pidfile PIDFILE] {subsys} [{daemon}]"
8a835e11 1017 return 2
1018 fi
bbb612de 1019
4e901aa0 1020 # if pidfile specified, pid must be there
24ab860c
ER
1021 if [ "$pidfile" ]; then
1022 [ -f "$pidfile" ] && read pid < $pidfile
305c3281
ER
1023 # filter_chroot does not filter out dead pids, so this extra check, see t/status-pidfile.sh
1024 if [ ! -d "/proc/$pid" ]; then
1025 pid=
1026 fi
4e901aa0
ER
1027 else
1028 pid=$(pidof -o $$ -o $PPID -o %PPID -x $daemon)
1029 fi
1c1b41b1 1030 pid=$(filter_chroot $pid)
bbb612de 1031
b90fbc1e 1032 if [ "$pid" ]; then
814e38ce 1033 cpuset_msg="..."
c51af89c
ER
1034 if [ -n "$SERVICE_CPUSET" ] && is_yes "$CPUSETS"; then
1035 if grep -q "$pid" "/dev/cpuset/${SERVICE_CPUSET}/tasks"; then
814e38ce
JR
1036 cpuset_msg=$(nls " in cpuset %s..." "$SERVICE_CPUSET")
1037 else
1038 cpuset_msg=$(nls " outside of configured cpuset %s..." "$SERVICE_CPUSET")
1039 fi
1040 fi
1041 nls "%s (pid %s) is running%s" "$daemon" "$pid" "$cpuset_msg"
8a835e11 1042 return 0
8a835e11 1043 fi
1044
1b59b41b 1045 # Next try "/var/run/*.pid" files; if pidfile is not set
4e901aa0 1046 local base=${daemon##*/}
1b59b41b 1047 if [ -z "$pidfile" -a -f /var/run/${base}.pid ]; then
8a835e11 1048 read pid < /var/run/${base}.pid
1c1b41b1 1049 pid=$(filter_chroot $pid)
1b59b41b
ER
1050 if [ "$pid" ]; then
1051 nls "%s dead but pid file (%s) exists" "$subsys" /var/run/${base}.pid
8a835e11 1052 return 1
1053 fi
1054 fi
1055
1056 # See if /var/lock/subsys/$subsys exists
1057 if [ -f /var/lock/subsys/$subsys ]; then
1b59b41b 1058 nls "daemon %s dead but subsys (%s) locked" "$daemon" "$subsys"
8a835e11 1059 return 2
7742e157 1060 fi
8a835e11 1061 nls "%s is stopped" "$subsys"
1062 return 3
7742e157 1063}
0524c81f 1064
6b4a354c
AM
1065# Confirm whether we really want to run this service
1066confirm() {
944d6d80 1067 local answer
d553f606 1068 nls -n "Start service %s (Y)es/(N)o/(C)ontinue? [Y] " "$1"
6b4a354c
AM
1069 read answer
1070 case $answer in
739070c4 1071 y|Y|t|T|j|J|"")
8a835e11 1072 return 0
6b4a354c 1073 ;;
739070c4 1074 c|C|k|K|w|W)
8a835e11 1075 return 2
6b4a354c 1076 ;;
739070c4 1077 n|N)
8a835e11 1078 return 1
6b4a354c 1079 ;;
739070c4 1080 *)
8a835e11 1081 confirm $1
1082 return $?
6b4a354c
AM
1083 ;;
1084 esac
1085}
1086
d553f606 1087# module is needed (ie. is requested, is available and isn't loaded already)
18bd13ac 1088is_module() {
d553f606 1089 # module name without .o at end
5778a670 1090 if ! lsmod | grep -q "$1"; then
63d30ecf 1091 if ls -1R /lib/modules/$(uname -r)/ 2> /dev/null | grep -q "^${1}.\(\|k\)o\(\|.gz\)"; then
d553f606
JR
1092 # true
1093 return 0
1094 fi
1095 fi
1096 # false
1097 return 1
0524c81f 1098}
f7b2d235 1099
18bd13ac 1100_modprobe() {
944d6d80 1101 local parsed single die args foo result
f7b2d235 1102 parsed=no
ac1f65e1 1103 while is_no "$parsed"; do
f7b2d235 1104 case "$1" in
739070c4 1105 "single")
8a835e11 1106 single=yes
1107 shift
1108 ;;
739070c4 1109 "die")
8a835e11 1110 die=yes
1111 shift
1112 ;;
739070c4 1113 -*)
8a835e11 1114 args="$args $1"
1115 shift
1116 ;;
739070c4 1117 *)
8a835e11 1118 parsed=yes
1119 ;;
f7b2d235
JR
1120 esac
1121 done
ac1f65e1 1122 if is_yes "${single}"; then
f7b2d235
JR
1123 foo="$@"
1124 show "Loading %s kernel module(s)" "$foo"
f7b2d235
JR
1125 busy
1126 fi
ac1f65e1 1127 if [ -x /sbin/modprobe ]; then
f7b2d235
JR
1128 /sbin/modprobe -s $args "$@"
1129 result=$?
1130 else
ac1f65e1 1131 deltext; fail
f7b2d235
JR
1132 result=1
1133 fi
ac1f65e1 1134 if is_yes "${single}"; then
f7b2d235 1135 deltext
ac1f65e1 1136 if [ $result = "0" ]; then
d553f606 1137 is_yes "$single" && ok
f7b2d235
JR
1138 else
1139 fail
ac1f65e1 1140 if is_yes "$die"; then
f7b2d235
JR
1141 nls "Could not load %s kernel module(s)" "$@"
1142 exit 1
1143 fi
1144 fi
1145 fi
f7b2d235 1146}
d553f606 1147
bc94aa53
ER
1148if is_no "$RC_LOGGING"; then
1149 log_success() {
1150 :
1151 }
d553f606 1152
18bd13ac 1153 log_failed() {
bc94aa53
ER
1154 :
1155 }
1156else
18bd13ac 1157 log_success() {
bc94aa53
ER
1158 initlog -n $0 -s "$1 $2" -e 1
1159 }
1160
18bd13ac 1161 log_failed() {
bc94aa53
ER
1162 initlog -n $0 -s "$1 $2" -e 2
1163 }
1164fi
d553f606 1165
f0c296a0
JR
1166# Check if any flavor of portmapper is running
1167check_portmapper() {
cbb91a00
ER
1168 if [ -x /usr/sbin/rpcinfo ]; then
1169 if /usr/sbin/rpcinfo -p localhost >/dev/null 2>/dev/null; then
fd8737b5 1170 return 0
f0c296a0
JR
1171 else
1172 return 1
1173 fi
5bf237b7
ER
1174 elif [ -z "$(pidof portmap)" -a -z "$(pidof rpcbind)" ]; then
1175 return 1
f0c296a0
JR
1176 fi
1177 return 0
1178}
1179
fab8c1a1
JR
1180# is_fsmounted fstype mntpoint
1181# Check if filesystem fstype is mounted on mntpoint
1182is_fsmounted() {
944d6d80
ER
1183 local fstype=$1
1184 local mntpoint=$2
fab8c1a1
JR
1185
1186 [ -n "$fstype" -a -n "$mntpoint" ] || return 1
1187
81ebaa15 1188 if [ -r /proc/mounts ]; then
bfd0227f 1189 grep -qE "[[:blank:]]$mntpoint[[:blank:]]+$fstype[[:blank:]]" /proc/mounts
81ebaa15 1190 return $?
fab8c1a1 1191 else
5bf237b7 1192 if [ "$(stat -L -f -c %T $mntpoint 2>/dev/null)" = "$fstype" ]; then
81ebaa15
JR
1193 return 0
1194 else
1195 return 1
1196 fi
fab8c1a1
JR
1197 fi
1198}
1199
83b3ef3b
AM
1200# __umount_loop awk_program fstab_file first_msg retry_msg umount_args
1201# awk_program should process fstab_file and return a list of fstab-encoded
1202# paths; it doesn't have to handle comments in fstab_file.
1203__umount_loop() {
1204 local remaining sig=
1205 local retry=3 count
1206
1207 remaining=$(LC_ALL=C awk "/^#/ {next} $1" "$2" | sort -r)
1208 while [ -n "$remaining" -a "$retry" -gt 0 ]; do
1209 if [ "$retry" -eq 3 ]; then
1210 run_cmd "$3" fstab-decode umount $5 $remaining
1211 else
1212 run_cmd "$4" fstab-decode umount $5 $remaining
1213 fi
1214 count=4
1215 remaining=$(LC_ALL=C awk "/^#/ {next} $1" "$2" | sort -r)
1216 while [ "$count" -gt 0 ]; do
1217 [ -z "$remaining" ] && break
1218 count=$(($count-1))
1219 usleep 500000
1220 remaining=$(LC_ALL=C awk "/^#/ {next} $1" "$2" | sort -r)
1221 done
1222 [ -z "$remaining" ] && break
a1170350 1223 fstab-decode /bin/fuser -k -m $sig $remaining >/dev/null
83b3ef3b
AM
1224 sleep 3
1225 retry=$(($retry -1))
1226 sig=-9
1227 done
1228}
1229
1230# Similar to __umount loop above, specialized for loopback devices
1231__umount_loopback_loop() {
1232 local remaining devremaining sig=
1233 local retry=3
1234
1235 remaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $2}' /proc/mounts)
1236 devremaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $1}' /proc/mounts)
1237 while [ -n "$remaining" -a "$retry" -gt 0 ]; do
1238 if [ "$retry" -eq 3 ]; then
1239 run_cmd "Unmounting loopback filesystems: " \
1240 fstab-decode umount $remaining
1241 else
1242 run_cmd "Unmounting loopback filesystems (retry):" \
1243 fstab-decode umount $remaining
1244 fi
1245 for dev in $devremaining ; do
1246 losetup $dev > /dev/null 2>&1 && \
1247 run_cmd "Detaching loopback device $dev: " \
1248 losetup -d $dev
1249 done
1250 remaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $2}' /proc/mounts)
1251 devremaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $1}' /proc/mounts)
1252 [ -z "$remaining" ] && break
a1170350 1253 fstab-decode /bin/fuser -k -m $sig $remaining >/dev/null
83b3ef3b
AM
1254 sleep 3
1255 retry=$(($retry -1))
1256 sig=-9
1257 done
1258}
1259
0084dcf3 1260rc_cache_init() {
6e311c54
ER
1261 # If we have cachefile, use it.
1262 # If we don't, create memory variables and try to save silently,
acf05b4f 1263 local cachefile='/var/cache/rc-scripts/msg.cache'
0084dcf3 1264
4132441e
ER
1265 local term
1266 if is_yes "$ISATTY"; then
1267 term=$TERM
1268 else
1269 term=dumb
1270 fi
1271
0084dcf3
ER
1272 # We create $check variable which is used to invalidate the cache.
1273 # The $check contains user locale and terminal.
66f7cfac 1274 local check="$term.$LC_MESSAGES.$INIT_COL"
0084dcf3 1275
f9df72e7 1276 if [ -f "$cachefile" -a "$cachefile" -nt /etc/sysconfig/system -a "$cachefile" -nt /etc/sysconfig/init-colors ]; then
0084dcf3
ER
1277 if . "$cachefile" 2>/dev/null; then
1278 if [ "$check" = "$_check" ]; then
1279 return
1280 fi
1281 fi
f9df72e7
ER
1282 fi
1283
1284 # primitive caching
1285 _busy=$(progress "BUSY" "$CBUSY")
1286 _ok=$(progress "DONE")
1287 _started=$(progress "WORK")
1288 _fail=$(progress "FAIL" "$CFAIL")
1289 _died=$(progress "DIED" "$CFAIL")
cc54351b
ER
1290
1291 # we don't use heredoc, as ksh attempts to create tempfile then
3ba0bc12 1292 (> "$cachefile" ) 2>/dev/null || return
cc54351b
ER
1293 echo "_busy='$_busy';" >> "$cachefile"
1294 echo "_ok='$_ok';" >> "$cachefile"
1295 echo "_started='$_started';" >> "$cachefile"
1296 echo "_fail='$_fail';" >> "$cachefile"
1297 echo "_died='$_died';" >> "$cachefile"
1298 echo "_check='$check';" >> "$cachefile"
f9df72e7
ER
1299}
1300
0084dcf3 1301rc_gettext_init() {
9a0a016d
ER
1302 if [ -z "$GETTEXT" ]; then
1303 if [ -x /bin/gettext -o -x /usr/bin/gettext ]; then
1304 GETTEXT=yes
1305 else
1306 GETTEXT=no
1307 fi
1308 fi
1309
1310 if [ -z "$TPUT" ]; then
ac1f65e1 1311 if [ -d /usr/share/terminfo ] && [ -x /usr/bin/tput -o -x /bin/tput ]; then
9a0a016d
ER
1312 TPUT=yes
1313 # check if we are on proper terminal
1314 tput longname >/dev/null 2>&1 || TPUT=no
1315 else
1316 TPUT=no
1317 fi
1318 fi
1319}
1320
439b6d80 1321use_upstart () {
f7943bf6 1322 return 1
439b6d80 1323}
439b6d80 1324emit () {
f7943bf6 1325 return 0
439b6d80 1326}
9ee04f3b 1327is_upstart_task() {
f7943bf6 1328 return 1
9ee04f3b
JK
1329}
1330is_upstart_running() {
f7943bf6 1331 return 1
9ee04f3b
JK
1332}
1333upstart_start() {
f7943bf6 1334 return 1
9ee04f3b
JK
1335}
1336upstart_stop() {
f7943bf6 1337 return 1
9ee04f3b
JK
1338}
1339upstart_reload() {
f7943bf6 1340 return 0
9ee04f3b
JK
1341}
1342upstart_status() {
f7943bf6 1343 return 1
9ee04f3b 1344}
6ca2a6ab 1345_upstart_controlled() {
f7943bf6 1346 return 0
439b6d80 1347}
945d7cfd 1348alias upstart_controlled='_upstart_controlled $0 "$@"'
439b6d80 1349
0084dcf3
ER
1350rc_gettext_init
1351rc_cache_init
f9df72e7 1352
bbb612de
AM
1353#/*
1354# * Local variables:
1355# * mode: sh
1356# * indent-tabs-mode: notnil
1357# * End:
1358# *
bbb612de 1359# */
This page took 3.672017 seconds and 4 git commands to generate.